unit UnitMainModbus;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls, FileCtrl{, FileCtrl} {Menus,Jpeg, FileCtrl};

type
  TFormMainModbus = class(TForm)
    LabelProgram: TLabel;
    LabelNazevProg: TLabel;
    LabelUser: TLabel;
    LabelUserName: TLabel;
    ButtonClose: TButton;
    LabelUserLoc: TLabel;
    ButtonHelp: TButton;
    Timer1: TTimer;
    LabelDate: TLabel;
    ButtonMemo: TButton;
    EditFilePar: TEdit;
    ButtonAbout: TButton;
    ButtonMereni: TButton;
    Label1: TLabel;
    FileListBoxPar: TFileListBox;
    Label2: TLabel;
    EditFileParPopis: TEdit;
    DirectoryListBoxPar: TDirectoryListBox;
    FilterComboBoxPar: TFilterComboBox;
    DriveComboBoxPar: TDriveComboBox;
    Label3: TLabel;
    EditParDatum: TEdit;
    EditFileAdresar: TEdit;
    ListBoxIni: TListBox;
    LabelVerse: TLabel;
    ButtonMainVstup: TButton;
    Label6: TLabel;
    Label7: TLabel;
    Label5: TLabel;
    ButtonMainErpar: TButton;
    Label9: TLabel;
    LabelMainInitStav: TLabel;
    ButtonParam: TButton;
    ButtonRevoDriver: TButton;
    ButtonHexPrepocet: TButton;
    EditModbusUser: TEdit;
    EditUserLocation: TEdit;
    ButtonMenuGrid: TButton;
    ButtonAnsiTest: TButton;
    ButtonInputs: TButton;
    ButtonAnsiData: TButton;
    ButtonAnsiControl: TButton;
    ButtonModbusAnsiStatus: TButton;
    ButtonMainGrafPar: TButton;
    CheckBoxDataTest: TCheckBox;
    procedure ButtonCloseClick(Sender: TObject);
    procedure ButtonAboutClick(Sender: TObject);
    procedure ButtonHelpClick(Sender: TObject);
    procedure ButtonMemoClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure ButtonMereniClick(Sender: TObject);
    {procedure ButtonModusTestRtuClick(Sender: TObject);}
    procedure FileListBoxParClick(Sender: TObject);
    procedure ButtonMainVstupClick(Sender: TObject);
    {procedure ListBoxMainParDblClick(Sender: TObject);}
    procedure ButtonMainErparClick(Sender: TObject);
    {procedure ListBoxMainParClick(Sender: TObject);}
    {procedure ButtonFtbArchivaceClick(Sender: TObject);}
    procedure ButtonParamClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    {procedure ButtonModusProcesClick(Sender: TObject);}
    procedure ButtonRevoDriverClick(Sender: TObject);
    procedure ButtonHexPrepocetClick(Sender: TObject);
    procedure ButtonMenuGridClick(Sender: TObject);
    procedure ButtonAnsiTestClick(Sender: TObject);
    procedure ButtonInputsClick(Sender: TObject);
    procedure ButtonAnsiDataClick(Sender: TObject);
    procedure ButtonAnsiControlClick(Sender: TObject);
    procedure ButtonModbusAnsiStatusClick(Sender: TObject);
    {procedure ButtonComTestClick(Sender: TObject);}
    procedure ButtonMainGrafParClick(Sender: TObject);
    procedure CheckBoxDataTestClick(Sender: TObject);
  private
    { Private declarations }
  public
				{ Public declarations }
  end;



var
	FormMainModbus: TFormMainModbus;



implementation

uses 	UnitProm, UnitPromCom, UnitPromModbus, UnitPromFtc, UnitPromGraf,
	    UnitProc, UnitProcFtm, UnitProcFtmModbus, UnitProcComApi, UnitHelp,
	    UnitVstupFtm, UnitMemo, UnitGridFtm, {UnitFtmUlohaQ,} UnitAboutFtm,
  	  UnitMerModbus, UnitCom32Api, UnitCom32set, UnitErrorFtm,
  	  UnitFtbParam, UnitFtmUlohaSoubor, {UnitUsbOpenFtc,}
      UnitFtmUlohaN, UnitModbusHex,
      UnitMerDrive, UnitInputs, UnitModbusAnsiData, UnitModbusAnsiTest,
  UnitModbusAnsiControl, UnitCom32test, UnitFtmGrafParams, UnitGrafParFile,
  UnitModbusAnsiStatus;


{$R *.DFM}

procedure LoadParametry;
label NejsouParametry;
var	Ps1: string;
begin
	{LoadFileParMain;}
	OK:=0;
  Errnum:=0;
  with FormFtbParam do
	 begin
    if FileExists(FilePar) then
			begin
				ListboxParam.Items.LoadFromFile(FilePar);
        ParamOn:=true;
			end
				else
         begin
          OK:=1;
			    Ps1:='File with parameters '+#13+FilePar+#13+' was not found !';
          Errnum:=Errnum+1;
          FormError.ListBoxError.Items.Add(Ps1);
         end;
    end;
   if OK=0 then
		       begin
            Errnum:=RozbalModbusTask;
            (*
            try
             Pb1:=RozbalModbusTask;
             except
              Ps1:='There are errors in par file !';
              FormError.ListBoxError.Items.Add(Ps1);
              OK:=14;
             end;
             *)
            if Errnum=0 then
             begin
                  Ps1:='File with parameters '+FileParName+' is OK';
                  MereniOn:=true;
                  ModbusOn:=true;
             end
              else
             begin
              Ps1:='In file with parameters '+FileParName+' are errors !!';
              MereniOn:=false;
              ModbusOn:=false;
             end;
            FormError.ListBoxError.Items.Add(Ps1);
           end
            else
           begin
            SM('File with parameters '+FilePar+' was not found !');
            ErrNum:=1;
            {goto NejsouParametry;}
           end;
        if Errnum=0 then
          begin
            ParStav('O.K.',clBlue);
            {FormMainFtm.ButtonMainErPar.visible:=false;}
          end
            else
          begin
            ParStav('Errors',clRed);
            {FormMainFtm.ButtonMainErPar.visible:=true;}
            SM('There are errors in files of parameters or driver !');
          end;
NejsouParametry:
end;


procedure ListBoxErrorClear(Nadpiss: string);
var	Ps1,Ps2: string;
begin
          FormError.ListBoxError.clear;
          Ps1:=Datum; Ps2:=Cas;
          FormError.EditErrorNadpis.Text:=ProgName+Progverse;
          FormError.ListBoxError.Items[0]:=Nadpiss;
          FormError.ListBoxError.Items[1]:=Ps1+' * '+Ps2;
          Errnum:=0;
end;

procedure TFormMainModbus.FormCreate(Sender: TObject);
begin
	{FileListBoxPar.FileEdit := EditFilePar;}
	FilterComboBoxPar.FileList := FileListBoxPar;
	DirectoryListBoxPar.FileList := FileListBoxPar;
	DriveComboBoxPar.DirList := DirectoryListBoxPar;
        {ButtonMainErpar.Visible:=false;}
        (*
	ButtonAbout.Caption:=TextAbout;
	ButtonClose.Caption:=TextClose;
	ButtonHelp.Caption:=TextHelp;
	ButtonMemo.Caption:=TextMemo;
	LabelProgram.Caption:=TextProgram;
	LabelUser.Caption:=TextUser;
        *)
	LabelVerse.Caption:='Verse: '+ProgVerse;
  EditModbusUser.text:='shareware';
  EditModbusUser.Enabled:=false;
  EditUserLocation.text:='shareware';
  EditUserLocation.enabled:=false;
  ParamOn:=false
end;


procedure TFormMainModbus.ButtonAnsiControlClick(Sender: TObject);
label  LoadDevices, Konec;
var    DeviceIndex : DWord;
       Ps1, Ps2,Ps3: string;
       I, Pi1, PortIndexPam: integer;
       Pb1,Pb2,Pb3: byte;
       PortIndexPom: byte;
begin
  TestyOn:=false;
  MereniOn:= false;
  NulujPriznakyOn;
  ModbusAnsiControlOn:=1;

  I:=1;
  Ps3:='';
  with FormFtbParam do
   begin
     Pb1:=1;
     DeviceAktual:=Pb1;
     Pb3:=DevicePortArray[Pb1]; {PortIndex}
     PortIndex:=Pb3;
     if ModbusDataTest then
      begin
       FormModbusAnsiControl.show;
       goto Konec;
      end;
     if not PortEnabled[Pb3] then
                     begin
                      Pb2:=RozbalDriverCom;
                      if Pb2>0 then
                       begin
                        str(Pb2,Ps2);
                        SM('Error in driver for device: '+IntToStr(Pb1)+' nr of error: '+Ps2);
                       end
                        else
                       begin
                        DevicePortArray[Pb1]:=PortIndex;
                        TestyOn:=true;
                       end;
                     end;

  if PortEnabled[PortIndex] then
        begin
          FormModbusAnsiControl.show;
          {FormTestKomunikaceFtc.show;}
        end
       else
        begin
         {FormCom32Set.ComboBoxPortIndex.ItemIndex:=Portindex;}
         str(PortIndex,Ps1);
         FormCom32set.EditPortIndex.Text:=Ps1;
         FormCom32Set.Show;
        end;
     end;
Konec:

end;

procedure TFormMainModbus.ButtonAnsiDataClick(Sender: TObject);
label  LoadDevices, Konec;
var    DeviceIndex : DWord;
       Ps1, Ps2,Ps3: string;
       I, Pi1, PortIndexPam: integer;
       Pb1,Pb2,Pb3: byte;
       PortIndexPom: byte;
begin
  TestyOn:=false;
  MereniOn:= false;
  NulujPriznakyOn;
  ModbusAnsiDataOn:=1;
  I:=1;
  Ps3:='';
  with FormFtbParam do
   begin
     Pb1:=1;
     DeviceAktual:=Pb1;
     Pb3:=DevicePortArray[Pb1]; {PortIndex}
     PortIndex:=Pb3;
     if ModbusDataTest then
      begin
       FormModbusAnsiData.show;
       goto Konec;
      end;
     if not PortEnabled[Pb3] then
                     begin
                      Pb2:=RozbalDriverCom;
                      if Pb2>0 then
                       begin
                        str(Pb2,Ps2);
                        SM('Error in driver for device: '+IntToStr(Pb1)+' nr of error: '+Ps2);
                       end
                        else
                       begin
                        DevicePortArray[Pb1]:=PortIndex;
                        TestyOn:=true;
                       end;
                     end;

  if PortEnabled[PortIndex] then
        begin
          FormModbusAnsiData.show;
          {FormTestKomunikaceFtc.show;}
        end
       else
        begin
         {FormCom32Set.ComboBoxPortIndex.ItemIndex:=Portindex;}
         str(PortIndex,Ps1);
         FormCom32set.EditPortIndex.Text:=Ps1;
         FormCom32Set.Show;
        end;
     end;
Konec:

end;

procedure TFormMainModbus.ButtonCloseClick(Sender: TObject);
label Konec;
var	Ps1,Ps2: string;
begin
  if ParIniChange then
		  begin
		    MD('Zmena v inicializacnim souboru - zaznam?',mtConfirmation,Ane);
		    if Ane then
		     begin
			    Ps1:=Datum;
			    Ps2:=Cas;
			    ListBoxIni.Items[2]:=Ps1+'/'+Ps2;
			    ListBoxIni.Items[3]:='User: shareware';
			    Ps1:=FileParName;
			    ListBoxIni.Items[5]:='File:'+Ps1;
			    ListBoxIni.Items.SaveToFile(FileIni);
		     end;
		  end;
      Konec:
	FormMainModbus.Close;
end;

procedure TFormMainModbus.ButtonAboutClick(Sender: TObject);
begin
	FormAbout.Show;
end;

procedure TFormMainModbus.ButtonHelpClick(Sender: TObject);
begin
	FormHelp.Show;
end;



procedure TFormMainModbus.ButtonHexPrepocetClick(Sender: TObject);
begin
  FormModbusHex.Show;
end;

procedure TFormMainModbus.ButtonInputsClick(Sender: TObject);
begin
  UlohaOn:=false;
  TabOn:=false;
  GrafFormOn:=false;
  FormInputs.show;
end;

procedure TFormMainModbus.ButtonMemoClick(Sender: TObject);
begin
  	if not MemoOn then
         begin
          FileMemo:=DriveName+'\'+ProgName+ProgVerse+FileMemoApend;
  	  if FileExists(FileMemo)
			then FormMemo.MemoBlok.Lines.LoadFromFile(FileMemo)
			else FormMemo.MemoBlok.Lines.SaveToFile(FileMemo);
          Memochange:=false;
          MemoOn:=true;
         end;
  	FormMemo.show;
end;

procedure TFormMainModbus.ButtonMenuGridClick(Sender: TObject);
begin
    FormGrid.Show;
end;

procedure TFormMainModbus.FormActivate(Sender: TObject);
label	NejsouParametry, OpakFilePar;
var Ps1, Ps2, Ps3 : string;
    Cp: integer;
	begin
   { Beep;}
   OK:=0; ErrNum:=0;
   if CheckBoxDataTest.Checked then
          begin
            ModbusDataTest:=true;
          end
           else
          begin
            ModbusDataTest:=false;
          end;;
   {ModbusDataTest:=true;}
   if ParamOn=false then
		 begin
      ListBoxErrorClear('Error messages from program Modbus:');
		  Ps1:=DirectoryListBoxPar.Directory;
		  DriveName:=Ps1;
      DrivePort:=Ps1;
		  Ps1:=ProgName+ProgVerse+'.ini';
		  FileIniName:=Ps1;
      Ps2:=DriveName+'\'+FileIniName;
		  FileIni:=Ps2;
		  EditFileAdresar.Text:=FileIni;
		  if not FileExists(FileIni) then
		   begin
        Errnum:=1;
		    Ps1:='no file for initialization !';
        FormError.ListBoxError.Items.Add(Ps1);
        Ps2:=FileIni;
        FormError.ListBoxError.Items.Add(Ps2);
        { Vytvorime tedy default !}
		    ListBoxIni.Items[0]:=ProgName+'/'+ProgVerse+'/'+'Inicializace';
		    ListBoxIni.Items[1]:='Inicializacni soubor pro program '+ProgName+ProgVerse;
		    Ps1:=Datum;
		    Ps2:=Cas;
		    ListBoxIni.Items[2]:=Ps1+'/'+Ps2;
		    ListBoxIni.Items[3]:='User:default';
		    ListBoxIni.Items[4]:='Path:Par';
		    ListBoxIni.Items[5]:='File:'+ProgName+ProgVerse+FileParApend;
		    ListBoxIni.Items[6]:='end';
		    ListBoxIni.Items.SaveToFile(FileIni);
        LabelMainInitStav.Font.Color:=clRed;
        LabelMainInitStav.Caption:='Chyby';
                    {ButtonMainErpar.Visible:=true;}
		   end
                    else
       begin
		      ListBoxIni.Items.LoadFromFile(FileIni);
          LabelMainInitStav.Font.Color:=clBlue;
          LabelMainInitStav.Caption:='o.k.';
          {ButtonMainErpar.Visible:=false;}
       end;
                  {ProgOn:=true;}
		  Ps1:=ListBoxIni.Items[3];
		  Ps2:=Sepstr(':',Ps1,Cp);
		  {EditOperator.text:=Ps1;}
		  Ps1:=ListBoxIni.Items[4];
		  Ps2:=Sepstr(':',Ps1,Cp);
      Ps1:=DriveName+'\'+Ps1+'\';
		  FileParPath:=Ps1;
      FileListBoxPar.Directory:=Ps1;
		  Ps1:=ListBoxIni.Items[5];
		  Ps2:=Sepstr(':',Ps1,Cp);
		  FileParName:=Ps1;
		  FileParNamePam:=Ps1;
      EditFilePar.text:=Ps1;
      {FilePar:=Ps3+Ps1;}
      FileParBasic:=Ps1;
		  {Ps2:=Sepstr('-',Ps1,Cp);}
		  Ps3:=Sepstr('.',Ps1,Cp);
      Ps2:=lowercase(Ps1);
      FileParExt:=Ps2;
      Ps2:=FileParPath;
      Ps1:=FileParPath+FileParName;
		  FilePar:=Ps1;
      LoadParametry;
     end;
		LabelDate.Caption:=Datum;
NejsouParametry:
end;


procedure TFormMainModbus.ButtonMereniClick(Sender: TObject);
label  InputDevices, Konec;
var    DeviceIndex : DWord;
       Ps1, Ps2,Ps3: string;
       I, Pi1, PortIndexPam: integer;
       Pb1,Pb2,Pb3: byte;
       PortIndexPom: byte;
begin
  TestyOn:=false;
  UlohaOn:=False;
  InputsyUlohaOn:=false;
  NulujPriznakyOn;
  ModbusMerOn:=1;
  I:=1;
  Ps3:='';
InputDevices:
    DeviceAktual:=1;
    UlohaOn:=false;
    DisplejOn:=false;
    TabOn:=false;
    GrafFormOn:=false;
    {ModbusOn:=false;}
    if not MereniOn then
     begin
      Errnum:=RozbalModbusTask;
      if Errnum=0 then
       begin
        MereniOn:=true;
        ModbusOn:=true;
       end
        else
       begin
        SM('There are errors in files of parameters or driver !');
        MereniOn:=false;
        ModbusOn:=false;
       end;
     end;
  Pb1:=1;
  Pb1:=DeviceAktual;
  Pb3:=DevicePortArray[Pb1]; {PortIndex}
  PortIndex:=Pb3;
  if ModbusDataTest then
   begin
    FormFtmUlohaN.show;
    goto Konec;
   end;
  if not PortEnabled[Pb3] then
                     begin
                      Pb2:=RozbalDriverCom;
                      if Pb2>0 then
                       begin
                        str(Pb2,Ps2);
                        SM('Error in driver for device: '+IntToStr(Pb1)+' nr of error: '+Ps2);
                       end
                        else
                       begin
                        DevicePortArray[Pb1]:=PortIndex;
                        MereniOn:=true;
                       end;
                     end;

  PortIndex:=DevicePortArray[DeviceAktual];
  if PortEnabled[PortIndex] then
        begin
	        FormFtmUlohaN.show;
          ModbusOn:=true;
          {FormModbusProces.show;}
          {FormTestKomunikaceFtc.show;}
        end
       else
        begin
         {FormCom32Set.ComboBoxPortIndex.ItemIndex:=Portindex;}
         FormCom32Set.Show;
        end;
  Konec:
end;


procedure TFormMainModbus.FileListBoxParClick(Sender: TObject);
label NejsouParametry, OpakFile;
var	Ps1, Ps2, Ps3: string;
        Cp: integer;
begin
OpakFile:
  ListBoxErrorClear('Cteni parametru:');
  ErrNum:=0;
	{ParamOn:=false;}
	with FileListboxPar do
		begin
		 FileParExt:=ExtractFileExt(FileName);
     Ps1:=ExtractFileName(FileName);
		 FileParName:=Ps1;
     Ps1:=ExtractFilePath(FileName);
                 (*
                 while Ps1<>'' do
                  begin
                   Ps2:=Sepstr('\',Ps1,Cp);
                  end;
                  *)
		 FileParPath:=Ps1;
		 FilePar:=FileName;
		 EditFileAdresar.Text:=FileName;
		 Ps1:=FileParName;
     EditFilePar.text:=FileParName;
                 {EditFileParPopis.text:=FormFtbParam.ListBoxParam.Items[1];}
		 {Ps2:=Sepstr('-',Ps1,Cp);}
		 Ps3:=Sepstr('.',Ps1,Cp);
     Ps1:=lowercase(Ps1);
     FileParExt:=Ps1;
     LoadParametry;
                 {if OK=0 then}
     ParInichange:=true;
    end;
end;

procedure TFormMainModbus.ButtonMainVstupClick(Sender: TObject);
begin
	FormVstup.show;
end;

(*
procedure TFormMainModbus.ListBoxMainParDblClick(Sender: TObject);
begin
	FormFtmUlohaSoubor.ListboxUloha.Items:=FormFtbParam.ListBoxParam.Items;
        FormFtmUlohaSoubor.show;
end;
*)

procedure TFormMainModbus.ButtonMainErparClick(Sender: TObject);
begin
	FormError.show;
end;

procedure TFormMainModbus.ButtonMainGrafParClick(Sender: TObject);
begin
  FormGrafParFile.show;
end;

(*
procedure TFormMainFtm.ListBoxMainParClick(Sender: TObject);
var	Pi1: integer;
	Ps1: string;
begin
	Pi1:=FormFtbParam.ListBoxParam.ItemIndex;
        Ps1:=FormFtbParam.ListBoxParam.Items[Pi1];
        EditMainParLine.Text:=Ps1;
end;
*)

(*
procedure TFormMainRevo.ButtonFtbArchivaceClick(Sender: TObject);
begin
	FormFtbArchiv.show;
end;
*)

procedure TFormMainModbus.ButtonParamClick(Sender: TObject);
begin
	FormFtbParam.show;
end;

procedure TFormMainModbus.ButtonRevoDriverClick(Sender: TObject);
begin
     FormMerDrive.show;
end;

procedure TFormMainModbus.CheckBoxDataTestClick(Sender: TObject);
begin
        if CheckBoxDataTest.Checked then
          begin
            ModbusDataTest:=true;
          end
           else
          begin
            ModbusDataTest:=false;
          end;
end;

procedure TFormMainModbus.ButtonAnsiTestClick(Sender: TObject);
label  LoadDevices, Konec;
var    DeviceIndex : DWord;
       Ps1, Ps2,Ps3: string;
       I, Pi1, PortIndexPam: integer;
       Pb1,Pb2,Pb3: byte;
       PortIndexPom: byte;
begin
  TestyOn:=false;
  MereniOn:= false;
  NulujPriznakyOn;
  ModbusAnsiTestOn:=1;

  I:=1;
  Ps3:='';
  with FormFtbParam do
   begin
     Pb1:=1;
     DeviceAktual:=Pb1;
     Pb3:=DevicePortArray[Pb1]; {PortIndex}
     PortIndex:=Pb3;
     if ModbusDataTest then
      begin
       FormModbusAnsiTest.show;
       goto Konec;
      end;
     if not PortEnabled[Pb3] then
                     begin
                      Pb2:=RozbalDriverCom;
                      if Pb2>0 then
                       begin
                        str(Pb2,Ps2);
                        SM('Error in driver for device: '+IntToStr(Pb1)+' nr of error: '+Ps2);
                       end
                        else
                       begin
                        DevicePortArray[Pb1]:=PortIndex;
                        TestyOn:=true;
                       end;
                     end;

  if PortEnabled[PortIndex] then
        begin
          FormModbusAnsiTest.show;
          {FormTestKomunikaceFtc.show;}
        end
       else
        begin
         {FormCom32Set.ComboBoxPortIndex.ItemIndex:=Portindex;}
         str(PortIndex,Ps1);
         FormCom32set.EditPortIndex.Text:=Ps1;
         FormCom32Set.Show;
        end;
     end;
Konec:
end;

procedure TFormMainModbus.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
     Comm32closeAll;
end;

procedure TFormMainModbus.ButtonModbusAnsiStatusClick(Sender: TObject);
label  LoadDevices, Konec;
var    DeviceIndex : DWord;
       Ps1, Ps2,Ps3: string;
       I, Pi1, PortIndexPam: integer;
       Pb1,Pb2,Pb3: byte;
       PortIndexPom: byte;
begin
  TestyOn:=false;
  MereniOn:= false;
  NulujPriznakyOn;
  ModbusAnsiStatusOn:=1;
  I:=1;
  Ps3:='';
  with FormFtbParam do
   begin
     Pb1:=1;
     DeviceAktual:=Pb1;
     Pb3:=DevicePortArray[Pb1]; {PortIndex}
     PortIndex:=Pb3;
     if ModbusDataTest then
      begin
       FormModbusAnsiStatus.show;
       goto Konec;
      end;
     if not PortEnabled[Pb3] then
                     begin
                      Pb2:=RozbalDriverCom;
                      if Pb2>0 then
                       begin
                        str(Pb2,Ps2);
                        SM('Error in driver for device: '+IntToStr(Pb1)+' nr of error: '+Ps2);
                       end
                        else
                       begin
                        DevicePortArray[Pb1]:=PortIndex;
                        TestyOn:=true;
                       end;
                     end;

  if PortEnabled[PortIndex] then
        begin
          FormCom32test.show;
          {FormTestKomunikaceFtc.show;}
        end
       else
        begin
         {FormCom32Set.ComboBoxPortIndex.ItemIndex:=Portindex;}
         str(PortIndex,Ps1);
         FormCom32set.EditPortIndex.Text:=Ps1;
         FormCom32Set.Show;
        end;
     end;
Konec:
  {FormCom32test.show;}
end;

(*
procedure TFormMainModbus.ButtonComTestClick(Sender: TObject);
label  LoadDevices, Konec;
var    DeviceIndex : DWord;
       Ps1, Ps2,Ps3: string;
       I, Pi1, PortIndexPam: integer;
       Pb1,Pb2,Pb3: byte;
       PortIndexPom: byte;
begin
  {Pi1:=NrOfDevices;}
  TestyOn:=false;
  MereniOn:= false;
  ModbusMerOn:=0;
  ModbusAnsiTestOn:=0;
  ModbusAnsiDataOn:=0;
  ModbusAnsiControlOn:=0;
  ModbusAnsiComTestOn:=1;
  I:=1;
  Ps3:='';
  with FormFtbParam do
   begin
     Pb1:=1;
     DeviceAktual:=Pb1;
     Pb3:=DevicePortArray[Pb1]; {PortIndex}
     PortIndex:=Pb3;
     if ModbusDataTest then
      begin
       FormCom32test.show;
       goto Konec;
      end;
     if not PortEnabled[Pb3] then
                     begin
                      Pb2:=RozbalDriverCom;
                      if Pb2>0 then
                       begin
                        str(Pb2,Ps2);
                        SM('Error in driver for device: '+IntToStr(Pb1)+' nr of error: '+Ps2);
                       end
                        else
                       begin
                        DevicePortArray[Pb1]:=PortIndex;
                        TestyOn:=true;
                       end;
                     end;

  if PortEnabled[PortIndex] then
        begin
          FormCom32test.show;
          {FormTestKomunikaceFtc.show;}
        end
       else
        begin
         {FormCom32Set.ComboBoxPortIndex.ItemIndex:=Portindex;}
         str(PortIndex,Ps1);
         FormCom32set.EditPortIndex.Text:=Ps1;
         FormCom32Set.Show;
        end;
     end;
Konec:
end;
*)

end.
